﻿/*
 *  Dll BarCodI25 (2 de 5 intercalado) 
 *  Classe     : BarCod25()
 *  Chamada    : Inicio(sequencia de caracteres para o codigo de barras, caminho completo para arqv jpeg)
 *  Programador: Jair Queiroz Lima
 *  Cria arquivo Jpeg do codigo de barras
 */
using System;
using System.Collections;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Drawing.Design;
using System.Drawing.Printing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using System.IO;
namespace BarCodI25
{
    public class BarCodI25 : System.Windows.Forms.Form
    { 
        private static String start = "NNNN";
        private static String stop = "WNN";
        private static String[] I25Pattern = { "NNWWN", "WNNNW", "NWNNW", "WWNNN", "NNWNW", "WNWNN", "NWWNN", "NNNWW", "WNNWN", "NWNWN" };
        private StringBuilder encoded = new StringBuilder();
        private float barra_altura    = (float)60; // Altura da Barra
        private float zona_silencio   = (float)22; // Zona de silencio
        private float barra_larga     = (float)4 ; //2.8; 2.5 2.0   // W=Larga         
        private float barra_estreita  = (float)2;  //1.5;   // N=Fina          
        private string LinDig;
        private string CodBar;
        Boolean autoQuietZones = true;
        Boolean autoStartStopMarks = true;
        Boolean retorno = true;
        public string inicio(String string_cod, String PathFile)
        {
            LinDig = string_cod;
            if (string_cod.Length >= 43)
            {
                CodBar = "";
                CodBar += LinDig.Substring(000, 003);  // codigo do banco
                CodBar += LinDig.Substring(003, 001);  // codigo da moeda (9=Real)
                CodBar += LinDig.Substring(032, 001);  // d¡gito verificador do c¢digo de barras
                CodBar += LinDig.Substring(033, 004);  // fator de vencimento
                CodBar += LinDig.Substring(037, 010);  // valor do documento
                CodBar += LinDig.Substring(004, 005);  // Campo livre - utilizado de acordo com especifica‡Æo interna do banco emissor
                CodBar += LinDig.Substring(010, 010);  // Campo livre - utilizado de acordo com especifica‡Æo interna do banco emissor
                CodBar += LinDig.Substring(021, 010);  // Campo livre - utilizado de acordo com especifica‡Æo interna do banco emissor
                string_cod = CodBar.Trim();
            }
            if ((string_cod.Length == 0) || (string_cod.Length % 2) != 0) { return "erro sequencia invalida"; }
            char[] c = string_cod.ToCharArray();
            if (autoQuietZones) encoded.Append("!");
            if (autoStartStopMarks) encoded.Append(start);
            for (int i = 0; i < string_cod.Length; i += 2)
            {
                if ((int)c[i] < 48 && (int)c[i] > 57) { return "erro contem caracter"; }
                String d1 = I25Pattern[c[i] - 48];
                String d2 = I25Pattern[c[i + 1] - 48];
                for (int n = 0; n <= 4; n++)
                {
                    encoded.Append(d1[n]);
                    encoded.Append(d2[n]);
                }
            }
            if (autoStartStopMarks) encoded.Append(stop);
            if (autoQuietZones) encoded.Append("!");
            if (encoded == null) return "Nulo";
            if (encoded.Length == 0) return "Vazio";
            for (int i = 0; i < encoded.Length; i++)
            {
                switch (encoded[i])
                {
                    case '!': break;
                    case 'N': break;
                    case 'W': break;
                    default:  retorno = false; break;
                }
            }
            if (!retorno) return "Invalidado";
            if (LinDig == null) LinDig = "Vazio LinDig";
            ImprimeGrafico(encoded, LinDig, PathFile);  // imprime o codigo de barras em PDF
            return encoded.ToString();                  // retorna a sequencia ASCII do codigo de barras
        } // Fim Inicio()
        private void ImprimeGrafico(StringBuilder encoded, String LinDig, String PathFile)
        {
            float largura = 0;
            float xtop = 10;
            float xboot = xtop;
            float y = 0; //610;
            Color corbarra = Color.White;
            Boolean bBar = false;
            int sz = 800;

            ResizeRedraw = true;
            Bitmap bmp = new Bitmap(sz, 50, System.Drawing.Imaging.PixelFormat.Format16bppRgb565);
            Graphics G = Graphics.FromImage(bmp);
            G.Clear(Color.White);
            Brush BrushPreto = new System.Drawing.SolidBrush(Color.Black);
            Brush BrushBranco = new System.Drawing.SolidBrush(Color.White);
            Pen PenaFina = new Pen(Color.Black);

            barra_altura += y;
            for (int i = 0; i < encoded.Length; i++)
            {
                switch (encoded[i])
                {
                    case '!':
                        largura = zona_silencio; bBar = false; break;
                    case 'N':
                        largura = barra_estreita; break;
                    case 'W':
                        largura = barra_larga; break;
                    default:
                        retorno = false; break;
                }
                if (bBar)
                {
                    PenaFina.Color = Color.Black;
                    G.FillRectangle(BrushPreto, xtop, 0, largura , barra_altura);
                }
                else
                {
                    PenaFina.Color = Color.White;
                    G.FillRectangle(BrushBranco, xtop, 0, largura, barra_altura);
                }
                G.DrawRectangle(PenaFina, xtop, y, largura, barra_altura);
                xtop += largura;
                xboot = xtop;
                bBar  = !bBar;
            }
            bmp.Save(PathFile, ImageFormat.Jpeg);
        }
        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // BarCodI25
            // 
            this.ClientSize = new System.Drawing.Size(292, 266);
            this.Name = "BarCodI25";
            //this.Load += new System.EventHandler(this.BarCodI25_Load);
            this.ResumeLayout(false);
        }
        //private void BarCodI25_Load(object sender, EventArgs e)
        //{
        //}
    } // Fim Class BarCodI25
} // Fim NameSpace BarCodI25

